diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/bindings/modulegen__gcc_LP64.py ns-3.34/src/lr-wpan/bindings/modulegen__gcc_LP64.py
--- ns-3.33/src/lr-wpan/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:06.000000000 -0700
@@ -115,12 +115,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -216,7 +220,7 @@
     ## trace-helper.h (module 'network'): ns3::PcapHelper [class]
     module.add_class('PcapHelper', import_from_module='ns.network')
     ## trace-helper.h (module 'network'): ns3::PcapHelper::DataLinkType [enumeration]
-    module.add_enum('DataLinkType', ['DLT_NULL', 'DLT_EN10MB', 'DLT_PPP', 'DLT_RAW', 'DLT_IEEE802_11', 'DLT_LINUX_SLL', 'DLT_PRISM_HEADER', 'DLT_IEEE802_11_RADIO', 'DLT_IEEE802_15_4', 'DLT_NETLINK'], outer_class=root_module['ns3::PcapHelper'], import_from_module='ns.network')
+    module.add_enum('DataLinkType', ['DLT_NULL', 'DLT_EN10MB', 'DLT_PPP', 'DLT_RAW', 'DLT_IEEE802_11', 'DLT_LINUX_SLL', 'DLT_PRISM_HEADER', 'DLT_IEEE802_11_RADIO', 'DLT_IEEE802_15_4', 'DLT_NETLINK', 'DLT_LORATAP'], outer_class=root_module['ns3::PcapHelper'], import_from_module='ns.network')
     ## trace-helper.h (module 'network'): ns3::PcapHelperForDevice [class]
     module.add_class('PcapHelperForDevice', allow_subclassing=True, import_from_module='ns.network')
     ## lr-wpan-fields.h (module 'lr-wpan'): ns3::PendingAddrFields [class]
@@ -507,6 +511,8 @@
     module.add_class('CallbackImpl', import_from_module='ns.core', parent=root_module['ns3::CallbackImplBase'], template_parameters=['void', 'ns3::SuperframeStatus', 'ns3::SuperframeStatus', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'])
     ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Time, ns3::LrWpanPhyEnumeration, ns3::LrWpanPhyEnumeration, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
     module.add_class('CallbackImpl', import_from_module='ns.core', parent=root_module['ns3::CallbackImplBase'], template_parameters=['void', 'ns3::Time', 'ns3::LrWpanPhyEnumeration', 'ns3::LrWpanPhyEnumeration', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'])
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
+    module.add_class('CallbackImpl', import_from_module='ns.core', parent=root_module['ns3::CallbackImplBase'], template_parameters=['void', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'])
     ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
     module.add_class('CallbackImpl', import_from_module='ns.core', parent=root_module['ns3::CallbackImplBase'], template_parameters=['void', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'])
     ## lr-wpan-net-device.h (module 'lr-wpan'): ns3::LrWpanNetDevice [class]
@@ -774,8 +780,10 @@
     register_Ns3GtsFields_methods(root_module, root_module['ns3::GtsFields'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3LrWpanEdPower_methods(root_module, root_module['ns3::LrWpanEdPower'])
@@ -923,6 +931,7 @@
     register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
     register_Ns3CallbackImpl__Void_Ns3SuperframeStatus_Ns3SuperframeStatus_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::SuperframeStatus, ns3::SuperframeStatus, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
     register_Ns3CallbackImpl__Void_Ns3Time_Ns3LrWpanPhyEnumeration_Ns3LrWpanPhyEnumeration_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Time, ns3::LrWpanPhyEnumeration, ns3::LrWpanPhyEnumeration, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
+    register_Ns3CallbackImpl__Void_Ns3Time_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
     register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
     register_Ns3LrWpanNetDevice_methods(root_module, root_module['ns3::LrWpanNetDevice'])
     register_Ns3HashImplementation_methods(root_module, root_module['ns3::Hash::Implementation'])
@@ -1926,6 +1935,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2139,6 +2160,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -2214,6 +2240,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2234,6 +2272,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
@@ -5067,11 +5110,11 @@
                    'void', 
                    [param('ns3::Ptr< ns3::MobilityModel >', 'm')], 
                    is_pure_virtual=True, is_virtual=True)
-    ## spectrum-phy.h (module 'spectrum'): ns3::Ptr<ns3::MobilityModel> ns3::SpectrumPhy::GetMobility() [member function]
+    ## spectrum-phy.h (module 'spectrum'): ns3::Ptr<ns3::MobilityModel> ns3::SpectrumPhy::GetMobility() const [member function]
     cls.add_method('GetMobility', 
                    'ns3::Ptr< ns3::MobilityModel >', 
                    [], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## spectrum-phy.h (module 'spectrum'): void ns3::SpectrumPhy::SetChannel(ns3::Ptr<ns3::SpectrumChannel> c) [member function]
     cls.add_method('SetChannel', 
                    'void', 
@@ -5082,11 +5125,11 @@
                    'ns3::Ptr< ns3::SpectrumModel const >', 
                    [], 
                    is_const=True, is_pure_virtual=True, is_virtual=True)
-    ## spectrum-phy.h (module 'spectrum'): ns3::Ptr<ns3::AntennaModel> ns3::SpectrumPhy::GetRxAntenna() [member function]
+    ## spectrum-phy.h (module 'spectrum'): ns3::Ptr<ns3::AntennaModel> ns3::SpectrumPhy::GetRxAntenna() const [member function]
     cls.add_method('GetRxAntenna', 
                    'ns3::Ptr< ns3::AntennaModel >', 
                    [], 
-                   is_pure_virtual=True, is_virtual=True)
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## spectrum-phy.h (module 'spectrum'): void ns3::SpectrumPhy::StartRx(ns3::Ptr<ns3::SpectrumSignalParameters> params) [member function]
     cls.add_method('StartRx', 
                    'void', 
@@ -6531,11 +6574,11 @@
                    'void', 
                    [param('ns3::Ptr< ns3::MobilityModel >', 'm')], 
                    is_virtual=True)
-    ## lr-wpan-phy.h (module 'lr-wpan'): ns3::Ptr<ns3::MobilityModel> ns3::LrWpanPhy::GetMobility() [member function]
+    ## lr-wpan-phy.h (module 'lr-wpan'): ns3::Ptr<ns3::MobilityModel> ns3::LrWpanPhy::GetMobility() const [member function]
     cls.add_method('GetMobility', 
                    'ns3::Ptr< ns3::MobilityModel >', 
                    [], 
-                   is_virtual=True)
+                   is_const=True, is_virtual=True)
     ## lr-wpan-phy.h (module 'lr-wpan'): void ns3::LrWpanPhy::SetChannel(ns3::Ptr<ns3::SpectrumChannel> c) [member function]
     cls.add_method('SetChannel', 
                    'void', 
@@ -6559,11 +6602,11 @@
     cls.add_method('SetAntenna', 
                    'void', 
                    [param('ns3::Ptr< ns3::AntennaModel >', 'a')])
-    ## lr-wpan-phy.h (module 'lr-wpan'): ns3::Ptr<ns3::AntennaModel> ns3::LrWpanPhy::GetRxAntenna() [member function]
+    ## lr-wpan-phy.h (module 'lr-wpan'): ns3::Ptr<ns3::AntennaModel> ns3::LrWpanPhy::GetRxAntenna() const [member function]
     cls.add_method('GetRxAntenna', 
                    'ns3::Ptr< ns3::AntennaModel >', 
                    [], 
-                   is_virtual=True)
+                   is_const=True, is_virtual=True)
     ## lr-wpan-phy.h (module 'lr-wpan'): ns3::Ptr<const ns3::SpectrumModel> ns3::LrWpanPhy::GetRxSpectrumModel() const [member function]
     cls.add_method('GetRxSpectrumModel', 
                    'ns3::Ptr< ns3::SpectrumModel const >', 
@@ -7842,6 +7885,28 @@
                    custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
+def register_Ns3CallbackImpl__Void_Ns3Time_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
+    cls.add_constructor([])
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
+    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
+    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
+    cls.add_method('DoGetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_static=True)
+    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
+    cls.add_method('GetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Time arg0) [member operator]
+    cls.add_method('operator()', 
+                   'void', 
+                   [param('ns3::Time', 'arg0')], 
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
+    return
+
 def register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
     ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
     cls.add_constructor([])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/examples/lr-wpan-data.cc ns-3.34/src/lr-wpan/examples/lr-wpan-data.cc
--- ns-3.33/src/lr-wpan/examples/lr-wpan-data.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/examples/lr-wpan-data.cc	2021-07-14 10:31:06.000000000 -0700
@@ -39,16 +39,32 @@
 
 using namespace ns3;
 
+/**
+ * Function called when a Data indication is invoked
+ * \param params MCPS data indication parameters
+ * \param p packet
+ */
 static void DataIndication (McpsDataIndicationParams params, Ptr<Packet> p)
 {
   NS_LOG_UNCOND ("Received packet of size " << p->GetSize ());
 }
 
+/**
+ * Function called when a Data confirm is invoked
+ * \param params MCPS data confirm parameters
+ */
 static void DataConfirm (McpsDataConfirmParams params)
 {
   NS_LOG_UNCOND ("LrWpanMcpsDataConfirmStatus = " << params.m_status);
 }
 
+/**
+ * Function called when a the PHY state changes
+ * \param context context
+ * \param now time at which the function is called
+ * \param oldState old PHY state
+ * \param newState new PHY state
+ */
 static void StateChangeNotification (std::string context, Time now, LrWpanPhyEnumeration oldState, LrWpanPhyEnumeration newState)
 {
   NS_LOG_UNCOND (context << " state change at " << now.As (Time::S)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc ns-3.34/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc
--- ns-3.33/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2021-07-14 10:31:06.000000000 -0700
@@ -54,10 +54,15 @@
 using namespace ns3;
 using namespace std;
 
-static uint32_t g_received = 0;
+static uint32_t g_received = 0; //!< number of packets received
 
 NS_LOG_COMPONENT_DEFINE ("LrWpanErrorDistancePlot");
 
+/**
+ * Function called when a Data indication is invoked
+ * \param params MCPS data indication parameters
+ * \param p packet
+ */
 static void
 LrWpanErrorDistanceCallback (McpsDataIndicationParams params, Ptr<Packet> p)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/examples/lr-wpan-phy-test.cc ns-3.34/src/lr-wpan/examples/lr-wpan-phy-test.cc
--- ns-3.33/src/lr-wpan/examples/lr-wpan-phy-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/examples/lr-wpan-phy-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -29,12 +29,23 @@
 
 using namespace ns3;
 
-void GetSetTRXStateConfirm (LrWpanPhyEnumeration status)
+/**
+ * Function called when a the PHY state change is confirmed
+ * \param status PHY state
+ */
+void
+GetSetTRXStateConfirm (LrWpanPhyEnumeration status)
 {
   NS_LOG_UNCOND ("At: " << Simulator::Now ()
                         << " Received Set TRX Confirm: " << status);
 }
 
+/**
+ * Function called when a the PHY receives a packet
+ * \param psduLength PSDU length
+ * \param p packet
+ * \param lqi link quality indication
+ */
 void
 ReceivePdDataIndication (uint32_t psduLength,
                          Ptr<Packet> p,
@@ -45,7 +56,13 @@
                  (uint16_t) lqi);
 }
 
-void SendOnePacket (Ptr<LrWpanPhy> sender, Ptr<LrWpanPhy> receiver)
+/**
+ * Send one packet
+ * \param sender sender PHY
+ * \param receiver receiver PHY
+ */
+void
+SendOnePacket (Ptr<LrWpanPhy> sender, Ptr<LrWpanPhy> receiver)
 {
   uint32_t n = 10;
   Ptr<Packet> p = Create<Packet> (n);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/helper/lr-wpan-helper.h ns-3.34/src/lr-wpan/helper/lr-wpan-helper.h
--- ns-3.33/src/lr-wpan/helper/lr-wpan-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/helper/lr-wpan-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -116,7 +116,7 @@
    * \brief Associate the nodes to the same PAN and initiate beacon enabled mode.
    *
    * \param c a set of nodes
-   * \param panID the PAN id
+   * \param panId the PAN id
    * \param coor the address of the PAN coordinator
    * \param bcnOrd indicates the interval between beacons.
    *               The value must be an int between 0 and 14.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/model/lr-wpan-fields.cc ns-3.34/src/lr-wpan/model/lr-wpan-fields.cc
--- ns-3.33/src/lr-wpan/model/lr-wpan-fields.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/model/lr-wpan-fields.cc	2021-07-14 10:31:06.000000000 -0700
@@ -179,14 +179,6 @@
   return i;
 }
 
-/**
- * output stream output operator
- *
- * \param os output stream
- * \param superframeField The Superframe Specification Field
- *
- * \returns output stream
- */
 std::ostream &
 operator << (std::ostream &os, const SuperframeField &superframeField)
 {
@@ -312,6 +304,13 @@
   return i;
 }
 
+std::ostream &
+operator << (std::ostream &os, const GtsFields &gtsFields)
+{
+  os << " GTS specification = "  << uint32_t (gtsFields.GetGtsSpecField ())
+     << ", GTS direction = "     << uint32_t (gtsFields.GetGtsDirectionField ());
+  return os;
+}
 
 /***********************************************************
  *              Pending Address Fields
@@ -472,14 +471,6 @@
   return i;
 }
 
-/**
- * output stream output operator
- *
- * \param os output stream
- * \param PendingAddrField the Pending Address Specification Field
- *
- * \returns output stream
- */
 std::ostream &
 operator << (std::ostream &os, const PendingAddrFields &pendingAddrFields)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/model/lr-wpan-fields.h ns-3.34/src/lr-wpan/model/lr-wpan-fields.h
--- ns-3.33/src/lr-wpan/model/lr-wpan-fields.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/model/lr-wpan-fields.h	2021-07-14 10:31:06.000000000 -0700
@@ -37,6 +37,7 @@
 namespace ns3 {
 
 /**
+ * \ingroup lr-wpan
  * The device Capabilities.
  */
 enum DeviceType
@@ -92,26 +93,32 @@
   void SetAssocPermit (bool assocPermit);
   /**
    * Get the Superframe Specification Beacon Order field.
+   * \return the Superframe Specification Beacon Order field.
    */
   uint8_t GetBeaconOrder (void) const;
   /**
    * Get the Superframe Specification Frame Order field.
+   * \return The Superframe Specification Frame Order field.
    */
   uint8_t GetFrameOrder (void) const;
   /**
-   * Check if the Final CAP Slot bit is enabled.
+   * Get the the Final CAP Slot.
+   * \returns The Final CAP Slot
    */
   uint8_t GetFinalCapSlot (void) const;
   /**
    * Check if the Battery Life Extension bit is enabled.
+   * \returns true if the Battery Life Extension bit is enabled
    */
   bool IsBattLifeExt (void) const;
   /**
    * Check if the PAN Coordinator bit is enabled.
+   * \returns true if the PAN Coordinator bit is enabled
    */
   bool IsPanCoor (void) const;
   /**
    * Check if the Association Permit bit is enabled.
+   * \returns true if the Association Permit bit is enabled
    */
   bool IsAssocPermit (void) const;
   /**
@@ -150,6 +157,14 @@
   bool    m_sspecAssocPermit; //!< Superframe Specification field Association Permit (Bit 15)
 
 };
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param [in] os The reference to the output stream.
+ * \param [in] superframeField The Superframe fields.
+ * \returns The reference to the output stream.
+ */
 std::ostream &operator << (std::ostream &os, const SuperframeField &superframeField);
 
 /**
@@ -174,12 +189,12 @@
   uint8_t GetGtsDirectionField (void) const;
   /**
    * Set the GTS Specification Field to the GTS Fields
-   * gtsSpec The GTS Specification Field to set.
+   * \param gtsSpec The GTS Specification Field to set.
    */
   void SetGtsSpecField (uint8_t gtsSpec);
   /**
    * Set the GTS direction field to the GTS Fields
-   * gtsDir The GTS Direction Field to set
+   * \param gtsDir The GTS Direction Field to set
    */
   void SetGtsDirectionField (uint8_t gtsDir);
   /**
@@ -201,7 +216,9 @@
   Buffer::Iterator Deserialize (Buffer::Iterator i);
 
 private:
-  //GTS Descriptor
+  /**
+   * GTS Descriptor
+   */
   struct gtsDescriptor
   {
     Mac16Address m_gtsDescDevShortAddr;      //!< GTS Descriptor Device Short Address (Bit 0-15)
@@ -211,14 +228,23 @@
 
   //GTS specification field
   uint8_t m_gtsSpecDescCount;            //!< GTS specification field Descriptor Count (Bit 0-2)
-                                         //!< GTS specification field Reserved (Not necessary) (Bit 3-6)
+                                         // GTS specification field Reserved (Not necessary) (Bit 3-6)
   uint8_t m_gtsSpecPermit;               //!< GTS specification field GTS Permit (Bit 7)
   //GTS Direction field
   uint8_t m_gtsDirMask;                  //!< GTS Direction field Directions Mask (Bit 0-6)
-                                         //!< GTS Direction field Reserved (Not Necessary) (Bit 7)
+                                         // GTS Direction field Reserved (Not Necessary) (Bit 7)
   //GTS List
-  gtsDescriptor m_gtsList[6];            //!< GTS List field (maximum descriptors stored == 7)
+  gtsDescriptor m_gtsList[7];            //!< GTS List field (maximum descriptors stored == 7)
 };
+
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param [in] os The reference to the output stream.
+ * \param [in] gtsFields The GTS fields.
+ * \returns The reference to the output stream.
+ */
 std::ostream &operator << (std::ostream &os, const GtsFields &gtsFields);
 
 
@@ -290,7 +316,7 @@
   Buffer::Iterator Serialize (Buffer::Iterator i) const;
   /**
    * Deserialize the all the Pending Address Fields.
-   * \param start an iterator which points to where the Pending Address Fields should be read.
+   * \param i an iterator which points to where the Pending Address Fields should be read.
    * \return an iterator.
    */
   Buffer::Iterator Deserialize (Buffer::Iterator i);
@@ -306,6 +332,14 @@
   std::array<Mac64Address,7>  m_extAddrList;      //!< Pending Extended Address List
 
 };
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param [in] os The reference to the output stream.
+ * \param [in] pendingAddrFields The Pending Address fields.
+ * \returns The reference to the output stream.
+ */
 std::ostream &operator << (std::ostream &os, const PendingAddrFields &pendingAddrFields);
 
 
